#!/bin/sh
#
# multiboot.sh from thowi
#
VERSION=20
#
MULTIBOOTKIT=multiboot$VERSION.tar
#
# experienced users can change the thinktime 
# before dangerous actions to a lower value or even 0 below
#
THINK=0
#
INSTALLDIR=/var/tmp
MBHOME=/media/cf
CF_KARTE=.cf-karte
CF_PATH=/dev/ide/host1/bus0/target0/lun0
#ls $CF_PATH
LOG=multiboot.log
#echo "---------- Starting $LOG ---------" > $LOG
HELP=/media/cf/readme.txt
CPSETTINGS=$MBHOME/cpsettings.sh
RMSETTINGS=$MBHOME/rmsettings.sh
SOURCE="/"
TARGET="/"
PARTITION_NAME=""
PLUGINDIR=/usr/lib/enigma2/python/Plugins/Extensions

# check for Cf card first
#      echo "-----------------------------------------------------"
         if  [ ! -d $CF_PATH ]; then
             echo "----------------------------------------------------"
             echo "CF Card not available - cann't do anything - EXITING !"
             echo "Try Rebooting with CF card inserted"
             echo "----------------------------------------------------"
             exit 1
#         else
#             echo "CF Card available ..."
         fi
cd $MBHOME

case "$1" in
   "man" | "m")
      echo "-----------------------------------------------------"
      if [ $THINK  != 0 ]; then
      echo "For scrolling trough help press space bar"
      echo "for finishing reading presse CTRL + C"
      echo "readme.txt will be shown in $THINK seconds"
      echo "-----------------------------------------------------"
      sleep $THINK
      fi
      echo "Showing $MBHOME/readme.txt"
      more $HELP
      exit 0
   ;;
   "log" | "l")
      echo "-----------------------------------------------------"
      echo "Display Logfile from last execution of" $0
#      echo "-----------------------------------------------------"
      if  [ ! -f $LOG ]; then
        echo "No log file available - sorry"
        exit 1
      else
#        ls -al $LOG
#        echo "-----------------------------------------------------"
        cat $LOG
        echo "-----------------------------------------------------"
      fi
      exit 0
      ;;
   "reboot" | "r")
      echo "------------------------------------------"
      if [ $THINK  != 0 ]; then
      echo "Rebooting in $THINK seconds"  
      echo "Press CTRL + C for interrupting"
      echo "------------------------------------------"
      sleep $THINK
      fi
      echo "Rebooting NOW"
      echo "------------------------------------------"
      shutdown -r now
      exit 0
   ;;
   "halt" | "h")
      echo "------------------------------------------"
      if [ $THINK  != 0 ]; then
      echo "Shutdown in $THINK seconds"  
      echo "Press CTRL + C for interrupting"
      echo "------------------------------------------"
      sleep $THINK
      fi
      echo "Shutting down NOW"
      echo "------------------------------------------"
      shutdown -h now
      exit 0
   ;;
   "kill" | "k")
      echo "------------------------------------------"
      if [ $THINK  != 0 ]; then
      echo "enigma2 will be restarted in $THINK seconds"
      echo "Press CTRL + C for interrupting"
      echo "------------------------------------------"
      sleep $THINK
      fi
      echo "enigma2 will be restarted NOW"
      killall enigma2
      exit 0
   ;;
   "plugin" | "p")
         echo "----------------------------------------------------"
      echo "Creating links for multiboot addon"
         if  [ -d $PLUGINDIR/Multiboot ]; then
#           echo "Changing Multiboot Plugin to be link to $MBHOME/Multiboot"
           rm -r $PLUGINDIR/Multiboot >> $LOG 2>&1
         fi
      ln -sf $MBHOME/Multiboot $PLUGINDIR 
      ln -sf $MBHOME/Multiboot /media/cf1/$PLUGINDIR 
      ln -sf $MBHOME/Multiboot /media/cf2/$PLUGINDIR
      ln -sf $MBHOME/Multiboot /media/cf3/$PLUGINDIR
         echo "----------------------------------------------------"
   exit 0
   ;;
   "info" | "i")
echo "---------- Starting $LOG ---------" > $LOG
      echo "------------------------------------------"
#      echo "Mounting Partitions if needed"
      if  [ !  -d /media/cf1 ]; then
        mkdir /media/cf1
      fi
      if  [ !  -d /media/cf2 ]; then
        mkdir /media/cf2
      fi
      if  [ !  -d /media/cf3 ]; then
        mkdir /media/cf3
      fi
        mount $CF_PATH/part2 /media/cf1 >> $LOG 2>&1
        mount $CF_PATH/part3 /media/cf2 >> $LOG 2>&1
        mount $CF_PATH/part4 /media/cf3 >> $LOG 2>&1
#      echo "Creating links for multiboot addon"
         if  [ -d $PLUGINDIR/Multiboot ]; then
#           echo "Changing Multiboot Plugin to be link to $MBHOME/Multiboot"
           rm -r $PLUGINDIR/Multiboot >> $LOG 2>&1
         fi
#        links only possible if Partition not empty
         if  [ -d $PLUGINDIR ]; then
             ln -sf $MBHOME/Multiboot $PLUGINDIR 
         fi
         if  [ -d /media/cf1/$PLUGINDIR ]; then
             ln -sf $MBHOME/Multiboot /media/cf1/$PLUGINDIR 
         fi
         if  [ -d /media/cf2/$PLUGINDIR ]; then
             ln -sf $MBHOME/Multiboot /media/cf2/$PLUGINDIR 
         fi
         if  [ -d /media/cf3/$PLUGINDIR ]; then
             ln -sf $MBHOME/Multiboot /media/cf3/$PLUGINDIR 
         fi
#      echo "Creating links in / for simplier access"
      cd /
      if  [ !  -d /cf ]; then
      ln -sf /media/cf 
      fi
      if  [ !  -d /cf1 ]; then
      ln -sf /media/cf1 
      fi
      if  [ !  -d /cf2 ]; then
      ln -sf /media/cf2 
      fi
      if  [ !  -d /cf3 ]; then
      ln -sf /media/cf3
      fi
#      echo "------------------------------------------"
      echo "Showing available Partitions"
      echo "------------------------------------------"
      if  [  -f /media/cf1/$CF_KARTE ]; then
          cat /media/cf1/$CF_KARTE
      fi
      if  [  -f /media/cf2/$CF_KARTE ]; then
          cat /media/cf2/$CF_KARTE
      fi
      if  [  -f /media/cf3/$CF_KARTE ]; then
          cat /media/cf3/$CF_KARTE
      fi
      echo "------------------------------------------"
      echo "You are bootet now from"
      echo "------------------------------------------"
      if  [ ! -f /$CF_KARTE ]; then
        echo "Flash !"
      else
        cat /$CF_KARTE
      fi
      echo "------------------------------------------"
      echo "autorun.bat on CF card for next reboot"
      echo "------------------------------------------"
      cat $MBHOME/autorun.bat
      echo "------------------------------------------"
#      echo "Linux Version"
#      uname -a
#      echo "Image Version"
#      cat /etc/image-version
#      cat /etc/version
#      echo "------------------------------------------"
      df -k | grep $MBHOME
      echo "------------------------------------------"
 exit 0
;;
   "autorun" | "a")
      echo "------------------------------------------"
      echo "autorun is now included in info option"
      echo "------------------------------------------"
      exit 1
   ;;
   "visible" | "v")
      echo "------------------------------------------"
      echo "visible is now ncluded in info option"
      echo "------------------------------------------"
      exit 1
   ;;

   "update" | "u")
echo "---------- Starting $LOG ---------" > $LOG
      echo "-----------------------------------------------------"
         echo "Updating Multiboot Boot Partiton from kit  ..."
      echo "-----------------------------------------------------"
      if  [ $0 != $INSTALLDIR/multiboot.sh ]; then
           echo "multiboot.sh should be called for $1 from /"
           echo "with $INSTALLDIR/multiboot.sh $1"
           echo "just checking if there is a kit to be extracted"
      echo "-----------------------------------------------------"
      if  [ ! -f $INSTALLDIR/multiboot*.tar.bz2 ]; then
         if  [ ! -f $INSTALLDIR/multiboot*.tar ]; then
             echo "nothing found at $INSTALLDIR"
             echo "using current multibootXX.tar kit from $MBHOME"
             cp $MBHOME/multiboot*.tar $INSTALLDIR
         else
             echo "using kit $INSTALLDIR/multibootXX.tar"
         fi
      else
      echo "using kit $INSTALLDIR/multibootXX.tar.bz2"
             cd $INSTALLDIR
             bunzip2 $INSTALLDIR/multiboot*.tar.bz2
      fi
      echo "Unpacking multibootXX kit"
      cd /
      tar -xf $INSTALLDIR/multiboot*.tar
      echo "-----------------------------------------------------"
           echo "Try now executing again with $INSTALLDIR/update.sh $1"
      echo "-----------------------------------------------------"
           exit 0
      fi
# kit now already unpacked at /var/tmp
# either manually, automatic from above or from Blue Pannel 
      echo "Copying Files from multiboot kit now to $MBHOME"
cd /
cp -r $PLUGINDIR/Multiboot $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/autorun.* $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/bootlogo.mvi $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/cpsettings.sh $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/rmsettings.sh $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/linkmb.bat $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/multiboot.sh $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/readme.txt $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/kit.sh $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/init.cmd $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/erase.cmd $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/dosfstools* $MBHOME >> $LOG 2>&1
cd /
#echo "rebuilding kit for later usage in $MBHOME"
tar -cf $MBHOME/multiboot$VERSION.tar $INSTALLDIR/autorun.* /usr/lib/enigma2/python/Plugins/Extensions/Multiboot $INSTALLDIR/bootlogo.mvi $INSTALLDIR/cpsettings.sh $INSTALLDIR/rmsettings.sh $INSTALLDIR/linkmb.bat $INSTALLDIR/erase.cmd $INSTALLDIR/init.cmd $INSTALLDIR/multiboot.sh $INSTALLDIR/readme.txt $INSTALLDIR/kit.sh $INSTALLDIR/dosfstools*
# convert readme.txt file to unix format
dos2unix $MBHOME/readme.txt
#       cleanup of extract directories if needed
         cd $MBHOME
         if  [ -d $MBHOME/var ]; then
         rm -r $MBHOME/var >> $LOG 2>&1
         fi
         if  [ -d $MBHOME/usr ]; then
         rm -r $MBHOME/usr >> $LOG 2>&1
         fi
         if  [ -d $PLUGINDIR/Multiboot ]; then
#           echo "Changing Multiboot Plugin to be link to $MBHOME/Multiboot"
           rm -r $PLUGINDIR/Multiboot >> $LOG 2>&1
         fi
#         echo "----------------------------------------------------"
#      echo "Creating links for multiboot addon"
      ln -sf $MBHOME/Multiboot $PLUGINDIR >> $LOG 2>&1
      ln -sf $MBHOME/Multiboot /media/cf1/$PLUGINDIR >> $LOG 2>&1
      ln -sf $MBHOME/Multiboot /media/cf2/$PLUGINDIR>> $LOG 2>&1
      ln -sf $MBHOME/Multiboot /media/cf3/$PLUGINDIR>> $LOG 2>&1
#         echo "----------------------------------------------------"
#      echo "Creating links in / for simplier access"
      cd /
      if  [ !  -d /cf ]; then
      ln -sf /media/cf 
      fi
      if  [ !  -d /cf1 ]; then
      ln -sf /media/cf1 
      fi
      if  [ !  -d /cf2 ]; then
      ln -sf /media/cf2 
      fi
      if  [ !  -d /cf3 ]; then
      ln -sf /media/cf3
      fi
      echo "-----------------------------------------------------"
      cd $MBHOME
         ;;
   "enable" | "e")
echo "---------- Starting $LOG ---------" > $LOG
      echo "-----------------------------------------------------"
         echo "Enabling CF card for Multiboot ..."
      if  [ $0 != $INSTALLDIR/multiboot.sh ]; then
           echo "multiboot.sh should be called for $1 from /"
           echo "with $INSTALLDIR/multiboot.sh $1"
           echo "just checking if there is a kit to be extracted"
      echo "-----------------------------------------------------"
      if  [ ! -f $INSTALLDIR/multiboot*.tar.bz2 ]; then
         if  [ ! -f $INSTALLDIR/multiboot*.tar ]; then
             echo "nothing found at $INSTALLDIR"
             echo "using current multibootXX.tar kit from $MBHOME"
             cp $MBHOME/multiboot*.tar $INSTALLDIR
         else
             echo "using kit $INSTALLDIR/multibootXX.tar"
         fi
      else
      echo "using kit $INSTALLDIR/multibootXX.tar.bz2"
             cd $INSTALLDIR
             bunzip2 $INSTALLDIR/multiboot*.tar.bz2
      fi
      echo "Unpacking multibootXX kit"
      cd /
      tar -xf $INSTALLDIR/multiboot*.tar
      echo "-----------------------------------------------------"
           echo "Try now executing again with $INSTALLDIR/update.sh $1"
      echo "-----------------------------------------------------"
           exit 0
      fi
# kit now already unpacked at /var/tmp
# either manually, automatic from above or from Blue Pannel 
      echo "-----------------------------------------------------"
         cd $INSTALLDIR
         umount /media/cf >> $LOG 2>&1
         umount /media/cf1 >> $LOG 2>&1
         umount /media/cf2 >> $LOG 2>&1
         umount /media/cf3 >> $LOG 2>&1
#         fdisk -v
         fdisk <init.cmd $CF_PATH/disc
#         ls $CF_PATH
         cd /
         if  [ ! -f /usr/sbin/mkdosfs ]; then
           echo "Installing dosfs tools to image"
           ipkg install $INSTALLDIR/dosfstools_2[1].10-r0_mipsel.ipk
         fi
         echo "Making Filesystems ..."
         mkdosfs -F 16 $CF_PATH/part1 >> $LOG 2>&1
         mkfs.ext3 $CF_PATH/part2 >> $LOG 2>&1
         mkfs.ext3 $CF_PATH/part3 >> $LOG 2>&1
         mkfs.ext3 $CF_PATH/part4 >> $LOG 2>&1
         echo "Making directories ..."
         if  [ !  -d $MBHOME ]; then
           mkdir $MBHOME
         fi
         mkdir /media/cf1
         mkdir /media/cf2
         mkdir /media/cf3
         echo "Mounting new Partitions ..."
         mount $CF_PATH/part1 /media/cf >>  $LOG 2>&1
         mount $CF_PATH/part2 /media/cf1 >> $LOG 2>&1
         mount $CF_PATH/part3 /media/cf2 >> $LOG 2>&1
         mount $CF_PATH/part4 /media/cf3 >> $LOG 2>&1
#         df -k
#          echo "-----------------------------------------------------"
         echo "Filling Boot Partition on CF card ..."
         cd /boot
         tar cf - * | ( cd /media/cf && tar xf - )
         cd  $MBHOME
#         echo "-----------------------------------------------------"
      echo "Copying Files from multiboot kit now to $MBHOME"
cd /
mkdir $MBHOME/Multiboot
# make sure that plugin directory is filled by re-extracting
tar -xf $INSTALLDIR/multiboot*.tar
cp -r $PLUGINDIR/Multiboot $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/autorun.* $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/bootlogo.mvi $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/cpsettings.sh $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/rmsettings.sh $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/linkmb.bat $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/multiboot.sh $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/readme.txt $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/kit.sh $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/init.cmd $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/erase.cmd $MBHOME >> $LOG 2>&1
cp $INSTALLDIR/dosfstools* $MBHOME >> $LOG 2>&1
cd /
echo "rebuilding kit for later usage in $MBHOME"
tar -cf $MBHOME/multiboot$VERSION.tar $INSTALLDIR/autorun.* /usr/lib/enigma2/python/Plugins/Extensions/Multiboot $INSTALLDIR/bootlogo.mvi $INSTALLDIR/cpsettings.sh $INSTALLDIR/rmsettings.sh $INSTALLDIR/linkmb.bat $INSTALLDIR/erase.cmd $INSTALLDIR/init.cmd $INSTALLDIR/multiboot.sh $INSTALLDIR/readme.txt $INSTALLDIR/kit.sh $INSTALLDIR/dosfstools*
# convert readme.txt file to unix format
dos2unix $MBHOME/readme.txt
#        cleanup of extract directories if needed
         cd $MBHOME
         if  [ -d $MBHOME/var ]; then
         rm -r $MBHOME/var >> $LOG 2>&1
         fi
         if  [ -d $MBHOME/usr ]; then
         rm -r $MBHOME/usr >> $LOG 2>&1
         fi
         if  [ -d $PLUGINDIR/Multiboot ]; then
           echo "Changing Multiboot Plugin to be link to $MBHOME/Multiboot"
           rm -r $PLUGINDIR/Multiboot >> $LOG 2>&1
         fi
#         echo "----------------------------------------------------"
      echo "Creating link for multiboot addon"
      ln -sf $MBHOME/Multiboot $PLUGINDIR 
#         echo "----------------------------------------------------"
#      echo "Creating links in / for simplier access"
      cd /
      if  [ !  -d /cf ]; then
      ln -sf /media/cf 
      fi
      if  [ !  -d /cf1 ]; then
      ln -sf /media/cf1 
      fi
      if  [ !  -d /cf2 ]; then
      ln -sf /media/cf2 
      fi
      if  [ !  -d /cf3 ]; then
      ln -sf /media/cf3
      fi
      echo "-----------------------------------------------------"
      cd $MBHOME
	;;
   "disable" | "d")
echo "---------- Starting $LOG ---------" > $LOG
      echo "-----------------------------------------------------"
         echo "Disabling CF card for Multiboot ..."
      if  [ $0 != $INSTALLDIR/multiboot.sh ]; then
           echo "multiboot.sh should be called for $1 from /"
           echo "with $INSTALLDIR/multiboot.sh $1"
           echo "just checking if there is a kit to be extracted"
      echo "-----------------------------------------------------"
      if  [ ! -f $INSTALLDIR/multiboot*.tar.bz2 ]; then
         if  [ ! -f $INSTALLDIR/multiboot*.tar ]; then
             echo "nothing found at $INSTALLDIR"
             echo "using current multibootXX.tar kit from $MBHOME"
             cp $MBHOME/multiboot*.tar $INSTALLDIR
         else
             echo "using kit $INSTALLDIR/multibootXX.tar"
         fi
      else
      echo "using kit $INSTALLDIR/multibootXX.tar.bz2"
             cd $INSTALLDIR
             bunzip2 $INSTALLDIR/multiboot*.tar.bz2
      fi
      echo "Unpacking multibootXX kit"
      cd /
      tar -xf $INSTALLDIR/multiboot*.tar
      echo "-----------------------------------------------------"
           echo "Try now executing again with $INSTALLDIR/update.sh $1"
      echo "-----------------------------------------------------"
           exit 0
      fi
# kit now already unpacked at /var/tmp
# either manually, automatic from above or from Blue Pannel 
         echo "-----------------------------------------------------"
         echo "Making sure that Flash boot is used from CF card "
         cd $INSTALLDIR
         cp $MBHOME/autorun.bat0 $MBHOME/autorun.bat >> $LOG 2>&1
         umount /media/cf >> $LOG 2>&1
         umount /media/cf1 >> $LOG 2>&1
         umount /media/cf2 >> $LOG 2>&1
         umount /media/cf3 >> $LOG 2>&1
         echo "Erasing CF card ...."
#         fdisk -v
         fdisk <erase.cmd $CF_PATH/disc
         echo "Making empty Filesystem ..."
         mkfs.ext3 $CF_PATH/disc >> $LOG 2>&1
         if  [ !  -d $MBHOME ]; then
           mkdir $MBHOME
         fi
         mount $CF_PATH/disc /media/cf >> $LOG 2>&1
         rmdir /media/cf1 >> $LOG 2>&1
         rmdir /media/cf2 >> $LOG 2>&1
         rmdir /media/cf3 >> $LOG 2>&1
         rm /cf /cf1 /cf2 /cf3 >> $LOG 2>&1
         rm -r $PLUGINDIR/Multiboot >> $LOG 2>&1
         mkdir $INSTALLDIR > /dev/null 2>&1
         echo "Disabling multiboot finished"
         echo "CF card should be mounted empty after a reboot"
         echo "maybe you have will have to check /etc/fstab"
         echo "-----------------------------------------------------"
	;;
   "extinguish" | "x")
         echo "-----------------------------------------------------"
         echo "Deleting an Image is now done by copy with source=target"
         echo "-----------------------------------------------------"
         exit 1
   ;;
   "setting" | "settings" | "s")
echo "---------- Starting $LOG ---------" > $LOG
         echo "------------------------------------------"
#         echo "Mounting all Multiboot Partitions - ignore errors if already mounted"
      if  [ !  -d /media/cf1 ]; then
        mkdir /media/cf1
      fi
      if  [ !  -d /media/cf2 ]; then
        mkdir /media/cf2
      fi
      if  [ !  -d /media/cf3 ]; then
        mkdir /media/cf3
      fi
        mount $CF_PATH/part2 /media/cf1 >> $LOG 2>&1
        mount $CF_PATH/part3 /media/cf2 >> $LOG 2>&1
        mount $CF_PATH/part4 /media/cf3 >> $LOG 2>&1
case "$2" in
   "1" | "2" | "3")
   echo  "Settings Copy Target Partition " $2
   TARGET=/media/cf$2
   ;;
   "0")
   echo "Target is currently booted image"
   TARGET="/"
   ;;
   *)
   echo ""
   echo "Usage $0 setting|s target{0|1|2|3} source{0|1|2|3}"
   echo "source argument passed is optional,"
   echo "Settings from booted Image will be used if not passed"
   exit 1
   ;;
esac
case "$3" in
   "1" | "2" | "3")
#   echo "Settings Copy Source Partition " $3
   SOURCE=/media/cf$3
      if  [  ! -f $SOURCE/$CF_KARTE ]; then
          echo "Source $SOURCE seems to be empty - cann't copy or delete"
          echo "----------------------------------------------------"
          exit 1
      fi
   ;;
   *)
#   echo "Using Settings from currently booted image as Source for copy or delete"
   SOURCE="/"
   ;;
esac
         if [ $SOURCE = $TARGET ]; then
             echo "----------------------------------------------------"
             echo "Deleting Settings from $2"
#             ls $RMSETTINGS
            if [ ! -f $RMSETTINGS ]; then
             echo $RMSETTINGS "is not available - nothing done !"
             echo "----------------------------------------------------"
             exit 1
         else
             echo $RMSETTINGS "available - executing"
             echo "----------------------------------------------------"
             $RMSETTINGS $TARGET $4 $5 $6
             exit 0
         fi
         fi
             echo "----------------------------------------------------"
 	 echo "Copying Settings from $SOURCE to $TARGET"
#             ls $CPSETTINGS
            if [ ! -f $CPSETTINGS ]; then
             echo $CPSETTINGS "is not available - nothing done !"
             echo "----------------------------------------------------"
             exit 1
         else
             echo $CPSETTINGS "available - executing"
             echo "----------------------------------------------------"
             $CPSETTINGS $TARGET $SOURCE $4 $5 $6
             exit 0
         fi
         exit 0
   ;;
   "copy" | "c")
echo "---------- Starting $LOG ---------" > $LOG
             echo "----------------------------------------------------"
#         echo "Mounting all 3 Partitions"
      if  [ !  -d /media/cf1 ]; then
        mkdir /media/cf1
      fi
      if  [ !  -d /media/cf2 ]; then
        mkdir /media/cf2
      fi
      if  [ !  -d /media/cf3 ]; then
        mkdir /media/cf3
      fi
        mount $CF_PATH/part2 /media/cf1 >> $LOG 2>&1
        mount $CF_PATH/part3 /media/cf2 >> $LOG 2>&1
        mount $CF_PATH/part4 /media/cf3 >> $LOG 2>&1
case "$2" in
   "1" | "2" | "3")
   echo  "Image Copy Target Partition " $2
   TARGET=/media/cf$2
   ;;
   "0")
   echo "Copying to, or deleting currently booted image is not possible"
        if  [ ! -f /$CF_KARTE ]; then
# 	 echo "Copying only booted Kernel from Flash to CF Boot Partition" $2
#         cp /boot/vmlinux.gz /media/cf/vmlinux.gz$2
         if  [ -d $PLUGINDIR/Multiboot ]; then
           echo "Changing only Multiboot Plugin to be link to $MBHOME/Multiboot"
           rm -r $PLUGINDIR/Multiboot >> $LOG 2>&1
         fi
#         echo "----------------------------------------------------"
#        echo "Creating link for multiboot addon"
         ln -sf $MBHOME/Multiboot $PLUGINDIR 
         if [ ! `grep /media/cf1 /etc/fstab` ]; then
         echo "Extending only /etc/fstab of booted Partiton"
         echo "$CF_PATH/part2 /media/cf1 auto defaults 0 0" >> /etc/fstab
         echo "$CF_PATH/part3 /media/cf2 auto defaults 0 0" >> /etc/fstab
         echo "$CF_PATH/part4 /media/cf3 auto defaults 0 0" >> /etc/fstab
         fi > /dev/null 2>&1
        fi
   TARGET="/"
             echo "----------------------------------------------------"
   exit 0
   ;;
   *)
   echo ""
   echo "Usage $0 copy|c target{1|2|3} source{0|1|2|3}"
   echo "source argument passed is optional,"
   echo "booted Image will be used if not passed"
   exit 1
   ;;
esac
#         echo "Changing next boot to Flash to prevent problems"
         cp $MBHOME/autorun.bat0 $MBHOME/autorun.bat
case "$3" in
   "1" | "2" | "3")
   echo "Image Copy Source Partition " $3
   SOURCE=/media/cf$3
   if [ $# = 3 ]; then
   PARTITION_NAME=Image$2
   else   
   PARTITION_NAME=$4
   fi
      if  [  ! -f $SOURCE/$CF_KARTE ]; then
          echo "Source $SOURCE seems to be empty - cann't copy or delete"
          echo "----------------------------------------------------"
          exit 1
      fi
   ;;
   "0")
   echo "Using currently booted image as Source for copy"
   SOURCE="/"
   if [ $# = 3 ]; then
   PARTITION_NAME=Image$2
   else   
   PARTITION_NAME=$4
   fi
   ;;
   *)
   echo "Using currently booted image as Source for copy"
   SOURCE="/"
   if [ $# = 2 ]; then
   PARTITION_NAME=Image$2
   else   
   PARTITION_NAME=$3
   fi
   ;;
esac
         if [ $SOURCE = $TARGET ]; then
         cd /media/cf$2
 	 echo "You will be cleaning Partition number" $2
         if [ $THINK  != 0 ]; then
         echo "------------------------------------------"
         echo "DO YOU REALLY WANT THIS ?"
         echo "If NOT then press CTRL + C in the next $THINK secs !"
         echo "------------------------------------------"
         sleep $THINK
         fi
         if  [ -f $TARGET/$CF_KARTE ]; then
         echo "Removing files ..."
         cd $TARGET
         rm -r * >> $LOG 2>&1
         rm $CF_KARTE >> $LOG 2>&1
         fi
         echo "Finished deleting Image in $TARGET" 
         exit 0
         fi
        echo "------------------------------------------"
         echo "Copying Image from $SOURCE to $TARGET"
         echo "Partition Name: $PARTITION_NAME"
        echo "------------------------------------------"
        echo "You are now bootet from"
        echo "------------------------------------------"
        if  [ ! -f /$CF_KARTE ]; then
          echo "Flash !"
        else
          cat /$CF_KARTE
        fi
        echo "------------------------------------------"
         if [ $THINK  != 0 ]; then
 	 echo "You will be overwriting Partition number" $2
         echo "------------------------------------------"
         echo "DO YOU REALLY WANT THIS ?"
         echo "If NOT then press CTRL + C in the next $THINK secs !"
         echo "------------------------------------------"
         sleep  $THINK
         fi
   case "$2" in
   "1" | "2" | "3")
         cd $TARGET
         if  [ -f $TARGET/$CF_KARTE ]; then
         echo "Removing Files ..."
         rm -r * >> $LOG 2>&1
         rm $CF_KARTE >> $LOG 2>&1
         fi
         cd $SOURCE
         echo "Copying Partition now - takes about 1 min ..."
         tar -cf - bin etc home lib sbin usr var | (cd $TARGET && tar xf - ) 
         cd $TARGET
         mkdir boot dev proc sys media
         cd $TARGET/media
         mkdir card cf cf1 cf2 cf3 cifs dvd hdd mmc1 net nfs ram realroot union usb
         echo "Filling Boot directory..."
         cd $SOURCE/boot
         tar cf - * | ( cd $TARGET/boot && tar xf - )
         echo "Labeling Partition ..."
         echo "Partition: " $2 "Name: " $PARTITION_NAME > $TARGET/$CF_KARTE
#         echo "Creating missing Links ..."
         cd $TARGET
         ln -sf /media/hdd hdd
         ln -sf /var/tmp tmp
         ln -sf /media mnt
         ln -sf /usr/share share
         echo "Copying kernel to CF Bootpartition ..."
         cp /boot/vmlinux.gz /media/cf/vmlinux.gz$2
         if [ ! `grep /media/cf1 /media/cf$2/etc/fstab` ]; then
         echo "Extending /etc/fstab of CF Partiton"
         echo "$CF_PATH/part2 /media/cf1 auto defaults 0 0" >> /media/cf$2/etc/fstab
         echo "$CF_PATH/part3 /media/cf2 auto defaults 0 0" >> /media/cf$2/etc/fstab
         echo "$CF_PATH/part4 /media/cf3 auto defaults 0 0" >> /media/cf$2/etc/fstab
         fi > /dev/null 2>&1
#         echo "Creating links in / for simplier access"
         cd $TARGET
#      echo "Creating links for simplier access"
      if  [ !  -d $TARGET/cf ]; then
      ln -sf /media/cf 
      fi
      if  [ !  -d $TARGET/cf1 ]; then
      ln -sf /media/cf1 
      fi
      if  [ !  -d $TARGET/cf2 ]; then
      ln -sf /media/cf2 
      fi
      if  [ !  -d $TARGET/cf3 ]; then
      ln -sf /media/cf3
      fi
         cd $MBHOME
         if  [ -d $PLUGINDIR/Multiboot ]; then
#           echo "Changing Multiboot Plugin to be link to $MBHOME/Multiboot"
           rm -r $TARGET/$PLUGINDIR/Multiboot >> $LOG 2>&1
         fi
#         echo "Creating link for multiboot addon"
         ln -sf $MBHOME/Multiboot $TARGET/$PLUGINDIR 
         echo "Finished copying Partition "
         echo "------------------------------------------"
	;;
    *)
	exit 1
	;;
esac
;;
   "name" | "n")
echo "---------- Starting $LOG ---------" > $LOG
             echo "----------------------------------------------------"
#         echo "Mounting all 3 Partitions"
      if  [ !  -d /media/cf1 ]; then
      mkdir /media/cf1
      fi
      if  [ !  -d /media/cf2 ]; then
      mkdir /media/cf2
      fi
      if  [ !  -d /media/cf3 ]; then
      mkdir /media/cf3
      fi
        mount $CF_PATH/part2 /media/cf1 >> $LOG 2>&1
        mount $CF_PATH/part3 /media/cf2 >> $LOG 2>&1
        mount $CF_PATH/part4 /media/cf3 >> $LOG 2>&1
case "$2" in
   "1" | "2" | "3")
   echo  "Naming Target Partition " $2
   TARGET=/media/cf$2
   ;;
   "0")
   echo "Naming currently booted Partition"
   TARGET="/"
   ;;
   *)
   echo "Usage $0 name|n {0|1|2|3}"
   echo "----------------------------------------------------"
   exit 1
   ;;
esac
        if  [ ! -f $TARGET/$CF_KARTE ]; then
          echo "Naming Flash or empty partition is not supported"
          echo "----------------------------------------------------"
          exit 1
        fi
         echo "Extending Partition Label with " $3
         cd $TARGET
         echo $3 >> $TARGET/$CF_KARTE
         cat $TARGET/$CF_KARTE
         echo "----------------------------------------------------"
	 exit 0
;;
"boot" | "b")
             echo "----------------------------------------------------"
case "$2" in
   "1" | "2" | "3")
         if  [ ! -f /media/cf$2/$CF_KARTE ]; then
         echo "Partition $2 seems to be empty, cann't boot from there !"
         exit 1
         fi
 	 echo "Changing next CF Boot Partition to" $2
         cp autorun.bat$2 autorun.bat
         cp vmlinux.gz$2 vmlinux.gz
         echo "----------------------------------------------------"
         cat /media/cf/autorun.bat
         echo "----------------------------------------------------"
	;;
    "0")
 	 echo "Changing next Boot Partition to Flash"
         cp autorun.bat$2 autorun.bat
         # kernel copy is not really needed because boot 0 means boot with kernel from flash
#         cp vmlinux.gz$2 vmlinux.gz
         echo "----------------------------------------------------"
         cat /media/cf/autorun.bat
         echo "----------------------------------------------------"
	;;
    *)
	echo "Usage: $0 boot  {0|1|2|3}"
	echo "Usage: $0 b  {0|1|2|3}"
	exit 1
	;;
esac

;;
    *)
        echo "-----------------------------------------------------"
	echo "Usage: $0 {enable|disable|copy|boot|setting|info|reboot|halt|kill|man}"
	echo "Usage: $0 {e|d|c|b|s|i|r|h|k|m}"
        echo "-----------------------------------------------------"
        echo "enable     option enables multiboot from CF card"
        echo "disable    option disables multiboot from CF card"
        echo "copy       option copies images to CF card"
        echo "boot       option selects which partition to boot next"
        echo "setting    option copies settings between images"
        echo "info       option displays info on installed and booted images"
        echo "reboot     option reboots Dreambox"
        echo "halt       option halts Dreambox - for example for flashing"
        echo "kill       option will restart only enigma2"
        echo "man        option displays longer help text"
        echo "-----------------------------------------------------"
	exit 1
	;;
esac
